
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef locoDemo_POSTER_LIB_H
#define locoDemo_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "locoDemoType.h"
#include "locoDemoError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[LOCODEMO_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} LOCODEMO_CNTRL_STR;

/* For consistency with other posters */
typedef LOCODEMO_CNTRL_STR LOCODEMO_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "locoDemoPosterLibStruct.h"



/* Posters */
#define LOCODEMO_CNTRL_POSTER_NAME genomInstanceSuffixName("locoDemo", "Cntrl")
#define LOCODEMO_MEPOS_POSTER_NAME genomInstanceSuffixName("locoDemo", "MEPos")
#define LOCODEMO_ODO_POSTER_NAME genomInstanceSuffixName("locoDemo", "Odo")
#define LOCODEMO_REF_POSTER_NAME genomInstanceSuffixName("locoDemo", "Ref")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS locoDemoPosterInit ( void );
extern POSTER_ID locoDemoCntrlPosterID ();
extern STATUS locoDemoCntrlPosterRead ( LOCODEMO_CNTRL_STR *locoDemoCntrlStrId );
extern STATUS locoDemoCntrlPosterInit ( void );
extern STATUS locoDemoCntrlInstancePosterRead(const char *name, LOCODEMO_CNTRL_STR *locoDemoCntrlStrId);
extern STATUS locoDemoMEPosPosterInit ( void );
extern POSTER_ID locoDemoMEPosPosterID ( void );
extern STATUS locoDemoMEPosPosterRead ( LOCODEMO_MEPOS_POSTER_STR *x );
extern STATUS locoDemoMEPosInstancePosterRead ( const char *, LOCODEMO_MEPOS_POSTER_STR * );
extern STATUS locoDemoMEPosmePosPosterRead ( POM_ME_POS *mePos );
extern STATUS locoDemoMEPosmePosInstancePosterRead( const char *, POM_ME_POS * );
extern STATUS locoDemoOdoPosterInit ( void );
extern POSTER_ID locoDemoOdoPosterID ( void );
extern STATUS locoDemoOdoPosterRead ( LOCODEMO_ODO_POSTER_STR *x );
extern STATUS locoDemoOdoInstancePosterRead ( const char *, LOCODEMO_ODO_POSTER_STR * );
extern STATUS locoDemoOdoRobotPosterRead ( GENPOS_CART_STATE *Robot );
extern STATUS locoDemoOdoRobotInstancePosterRead( const char *, GENPOS_CART_STATE * );
extern STATUS locoDemoRefPosterInit ( void );
extern POSTER_ID locoDemoRefPosterID ( void );
extern STATUS locoDemoRefPosterRead ( LOCODEMO_REF_POSTER_STR *x );
extern STATUS locoDemoRefInstancePosterRead ( const char *, LOCODEMO_REF_POSTER_STR * );
extern STATUS locoDemoRefRefPosterRead ( GENPOS_CART_REF *Ref );
extern STATUS locoDemoRefRefInstancePosterRead( const char *, GENPOS_CART_REF * );
#ifdef __cplusplus
}
#endif
#endif

