
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] locoDemoInstall] >= 0 } {
    interp expose {} locoDemoInstall
}

proc ::locoDemoInstall { name } {
    foreach rqst { "GetConfig" "SetConfig" "GetRef" "SetRef" "GetCmdParam" "SetCmdParam" "Stop" "Track" "SurvLine" "SetPom" "MEPosmePosPosterRead" "OdoRobotPosterRead" "RefRefPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} locoDemo$rqst $name
    }
}

interp hide {} locoDemoInstall




# GetConfig ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoGetConfig] >= 0 } {
    interp expose {} locoDemoGetConfig
}
if { [lsearch [interp hidden] locoDemoGetConfigFormatOutput] >= 0 } {
    interp expose {} locoDemoGetConfigFormatOutput
}

proc ::locoDemoGetConfig { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetConfig" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::locoDemoGetConfigFormatOutput { list } {
    set format { {} status { } { robot { } xRef { } yRef { } xRob { } yRob { } theta { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoGetConfig
interp hide {} locoDemoGetConfigFormatOutput





# SetConfig ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoSetConfig] >= 0 } {
    interp expose {} locoDemoSetConfig
}
if { [lsearch [interp hidden] locoDemoSetConfigFormatOutput] >= 0 } {
    interp expose {} locoDemoSetConfigFormatOutput
}

proc ::locoDemoSetConfig { name args } {
    set format {}
    lappend format [list double "robot.xRef" 0.0 ]
    lappend format [list double "robot.yRef" 0.0 ]
    lappend format [list double "robot.xRob" 0.0 ]
    lappend format [list double "robot.yRob" 0.0 ]
    lappend format [list double "robot.theta" 0.0 ]
    lappend format [list double "robot.v" 0.0 ]
    lappend format [list double "robot.vt" 0.0 ]
    lappend format [list double "robot.w" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetConfig" \
	"** undocumented **" \
	"GENPOS_CART_STATE\n| double xRef\n| double yRef\n| double xRob\n| double yRob\n| double theta\n| double v\n| double vt\n| double w\n" \
	8 \
	$format \
	$args ]
}


proc ::locoDemoSetConfigFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoSetConfig
interp hide {} locoDemoSetConfigFormatOutput





# GetRef ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoGetRef] >= 0 } {
    interp expose {} locoDemoGetRef
}
if { [lsearch [interp hidden] locoDemoGetRefFormatOutput] >= 0 } {
    interp expose {} locoDemoGetRefFormatOutput
}

proc ::locoDemoGetRef { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetRef" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::locoDemoGetRefFormatOutput { list } {
    set format { {} status { } { ref { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoGetRef
interp hide {} locoDemoGetRefFormatOutput





# SetRef ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoSetRef] >= 0 } {
    interp expose {} locoDemoSetRef
}
if { [lsearch [interp hidden] locoDemoSetRefFormatOutput] >= 0 } {
    interp expose {} locoDemoSetRefFormatOutput
}

proc ::locoDemoSetRef { name args } {
    set format {}
    lappend format [list int "ref.numRef" 0 ]
    lappend format [list int "ref.tickPeriod" 0 ]
    lappend format [list { "GENPOS_POS_AND_SPEED_DATA" "GENPOS_SPEED_DATA" "GENPOS_POS_DATA" } "ref.dataType" "" ]
    lappend format [list { "GENPOS_BACKWARD_MOTION" "GENPOS_FORWARD_MOTION" } "ref.backFlag" "" ]
    lappend format [list double "ref.x" 0.0 ]
    lappend format [list double "ref.y" 0.0 ]
    lappend format [list double "ref.theta" 0.0 ]
    lappend format [list double "ref.v" 0.0 ]
    lappend format [list double "ref.vt" 0.0 ]
    lappend format [list double "ref.w" 0.0 ]
    lappend format [list double "ref.vmax" 0.0 ]
    lappend format [list double "ref.wmax" 0.0 ]
    lappend format [list double "ref.linAccelMax" 0.0 ]
    lappend format [list double "ref.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetRef" \
	"** undocumented **" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	14 \
	$format \
	$args ]
}


proc ::locoDemoSetRefFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoSetRef
interp hide {} locoDemoSetRefFormatOutput





# GetCmdParam ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoGetCmdParam] >= 0 } {
    interp expose {} locoDemoGetCmdParam
}
if { [lsearch [interp hidden] locoDemoGetCmdParamFormatOutput] >= 0 } {
    interp expose {} locoDemoGetCmdParamFormatOutput
}

proc ::locoDemoGetCmdParam { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetCmdParam" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::locoDemoGetCmdParamFormatOutput { list } {
    set format { {} status { } { cmd { } distPoint { } KpLongit { } KiLongit { } KpTransv { } KiTransv { } KpAng { } KiAng { } longitErrorMax { } transvErrorMax { } longitMaxErrSum { } transvMaxErrSum { } angErrorMax { } angMaxErrSum { } longitMaxGap { } transvMaxGap { } angMaxGap } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoGetCmdParam
interp hide {} locoDemoGetCmdParamFormatOutput





# SetCmdParam ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoSetCmdParam] >= 0 } {
    interp expose {} locoDemoSetCmdParam
}
if { [lsearch [interp hidden] locoDemoSetCmdParamFormatOutput] >= 0 } {
    interp expose {} locoDemoSetCmdParamFormatOutput
}

proc ::locoDemoSetCmdParam { name args } {
    set format {}
    lappend format [list double "cmd.distPoint" 0.0 ]
    lappend format [list double "cmd.KpLongit" 0.0 ]
    lappend format [list double "cmd.KiLongit" 0.0 ]
    lappend format [list double "cmd.KpTransv" 0.0 ]
    lappend format [list double "cmd.KiTransv" 0.0 ]
    lappend format [list double "cmd.KpAng" 0.0 ]
    lappend format [list double "cmd.KiAng" 0.0 ]
    lappend format [list double "cmd.longitErrorMax" 0.0 ]
    lappend format [list double "cmd.transvErrorMax" 0.0 ]
    lappend format [list double "cmd.longitMaxErrSum" 0.0 ]
    lappend format [list double "cmd.transvMaxErrSum" 0.0 ]
    lappend format [list double "cmd.angErrorMax" 0.0 ]
    lappend format [list double "cmd.angMaxErrSum" 0.0 ]
    lappend format [list double "cmd.longitMaxGap" 0.0 ]
    lappend format [list double "cmd.transvMaxGap" 0.0 ]
    lappend format [list double "cmd.angMaxGap" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetCmdParam" \
	"** undocumented **" \
	"GENPOS_CART_CMD_PARAM\n| double distPoint\n| double KpLongit\n| double KiLongit\n| double KpTransv\n| double KiTransv\n| double KpAng\n| double KiAng\n| double longitErrorMax\n| double transvErrorMax\n| double longitMaxErrSum\n| double transvMaxErrSum\n| double angErrorMax\n| double angMaxErrSum\n| double longitMaxGap\n| double transvMaxGap\n| double angMaxGap\n" \
	16 \
	$format \
	$args ]
}


proc ::locoDemoSetCmdParamFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoSetCmdParam
interp hide {} locoDemoSetCmdParamFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoStop] >= 0 } {
    interp expose {} locoDemoStop
}
if { [lsearch [interp hidden] locoDemoStopFormatOutput] >= 0 } {
    interp expose {} locoDemoStopFormatOutput
}

proc ::locoDemoStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::locoDemoStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoStop
interp hide {} locoDemoStopFormatOutput





# Track ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoTrack] >= 0 } {
    interp expose {} locoDemoTrack
}
if { [lsearch [interp hidden] locoDemoTrackFormatOutput] >= 0 } {
    interp expose {} locoDemoTrackFormatOutput
}

proc ::locoDemoTrack { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Track" \
	"** undocumented **" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::locoDemoTrackFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoTrack
interp hide {} locoDemoTrackFormatOutput





# SurvLine ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoSurvLine] >= 0 } {
    interp expose {} locoDemoSurvLine
}
if { [lsearch [interp hidden] locoDemoSurvLineFormatOutput] >= 0 } {
    interp expose {} locoDemoSurvLineFormatOutput
}

proc ::locoDemoSurvLine { name args } {
    set format {}
    for {set loop1(0) 0} { $loop1(0)<2 } { incr loop1(0)} {
    lappend format [list double "survLineStr.pt1\[$loop1(0)\]" 0.0 ]
}
    for {set loop1(0) 0} { $loop1(0)<2 } { incr loop1(0)} {
    lappend format [list double "survLineStr.pt2\[$loop1(0)\]" 0.0 ]
}

    return [ ::cs::rqstSend "${name}" "SurvLine" \
	"** undocumented **" \
	"SURV_LINE_STR\n| double pt1\[2\]\n| double pt2\[2\]\n" \
	4 \
	$format \
	$args ]
}


proc ::locoDemoSurvLineFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoSurvLine
interp hide {} locoDemoSurvLineFormatOutput





# SetPom ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoSetPom] >= 0 } {
    interp expose {} locoDemoSetPom
}
if { [lsearch [interp hidden] locoDemoSetPomFormatOutput] >= 0 } {
    interp expose {} locoDemoSetPomFormatOutput
}

proc ::locoDemoSetPom { name args } {
    set format {}
    lappend format [list string "mePosterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "SetPom" \
	"** undocumented **" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::locoDemoSetPomFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoSetPom
interp hide {} locoDemoSetPomFormatOutput





# MEPosmePos ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoMEPosmePosPosterRead] >= 0 } {
    interp expose {} locoDemoMEPosmePosPosterRead
}
if { [lsearch [interp hidden] locoDemoMEPosmePosPosterFormatOutput] >= 0 } {
    interp expose {} locoDemoMEPosmePosPosterFormatOutput
}

proc ::locoDemoMEPosmePosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosmePos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::locoDemoMEPosmePosPosterFormatOutput { list } {
    set format { {} status { } { mePos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoMEPosmePosPosterRead
interp hide {} locoDemoMEPosmePosPosterFormatOutput





# OdoRobot ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoOdoRobotPosterRead] >= 0 } {
    interp expose {} locoDemoOdoRobotPosterRead
}
if { [lsearch [interp hidden] locoDemoOdoRobotPosterFormatOutput] >= 0 } {
    interp expose {} locoDemoOdoRobotPosterFormatOutput
}

proc ::locoDemoOdoRobotPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "OdoRobot" \
	"GENPOS_CART_STATE\n| double xRef\n| double yRef\n| double xRob\n| double yRob\n| double theta\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::locoDemoOdoRobotPosterFormatOutput { list } {
    set format { {} status { } { Robot { } xRef { } yRef { } xRob { } yRob { } theta { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoOdoRobotPosterRead
interp hide {} locoDemoOdoRobotPosterFormatOutput





# RefRef ----------------------------------------------------------

if { [lsearch [interp hidden] locoDemoRefRefPosterRead] >= 0 } {
    interp expose {} locoDemoRefRefPosterRead
}
if { [lsearch [interp hidden] locoDemoRefRefPosterFormatOutput] >= 0 } {
    interp expose {} locoDemoRefRefPosterFormatOutput
}

proc ::locoDemoRefRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RefRef" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::locoDemoRefRefPosterFormatOutput { list } {
    set format { {} status { } { Ref { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} locoDemoRefRefPosterRead
interp hide {} locoDemoRefRefPosterFormatOutput


